Attribute VB_Name = "basSysMenu"
' SysMenu.bas
'
Option Explicit

Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" _
     (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal Msg As Long, _
     ByVal wParam As Long, ByVal lParam As Long) As Long
Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, _
     ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Declare Function GetProp Lib "user32" Alias "GetPropA" (ByVal hWnd As Long, _
     ByVal lpString As String) As Long
Declare Function RemoveProp Lib "user32" Alias "RemovePropA" (ByVal hWnd As Long, _
     ByVal lpString As String) As Long
Declare Function GetMenu Lib "user32" (ByVal hWnd As Long) As Long
Declare Function GetSubMenu Lib "user32" (ByVal hMenu As Long, ByVal nPos As Long) As Long
Declare Function RemoveMenu Lib "user32" (ByVal hMenu As Long, ByVal nPosition As Long, _
     ByVal wFlags As Long) As Long
Declare Function DeleteMenu Lib "user32" (ByVal hMenu As Long, ByVal nPosition As Long, _
     ByVal wFlags As Long) As Long
Declare Function InsertMenu Lib "user32" Alias "InsertMenuA" (ByVal hMenu As Long, _
     ByVal nPosition As Long, ByVal wFlags As Long, ByVal wIDNewItem As Long, _
     ByVal lpNewItem As Any) As Long
Declare Function ModifyMenu Lib "user32" Alias "ModifyMenuA" (ByVal hMenu As Long, _
     ByVal nPosition As Long, ByVal wFlags As Long, ByVal wIDNewItem As Long, _
     ByVal lpString As String) As Long
Declare Function AppendMenu Lib "user32" Alias "AppendMenuA" (ByVal hMenu As Long, _
     ByVal wFlags As Long, ByVal wIDNewItem As Long, ByVal lpNewItem As String) As Long
Declare Function CreatePopupMenu Lib "user32" () As Long
Declare Function GetSystemMenu Lib "user32" (ByVal hWnd As Long, ByVal bRevert As Long) As Long
Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, _
     ByVal lpWindowName As String) As Long

Public Const MF_ENABLED = &H0&
Public Const MF_STRING = &H0&
Public Const MF_GRAYED = &H1&
Public Const MF_DISABLED = &H2&
Public Const MF_POPUP = &H10&
Public Const MF_BYPOSITION = &H400&
Public Const MF_SEPARATOR = &H800&
Public Const WM_CLOSE = &H10
Public Const WM_COMMAND = &H111
Public Const WM_SYSCOMMAND = &H112
Public Const WM_MENUSELECT = &H11F
Public Const WM_USER = &H400
Public Const GWL_WNDPROC = (-4)

Public OldWinProc As Long
Dim mresult



Public Function NewWindowProc(ByVal inHWND As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    If Msg = WM_COMMAND Then
        If wParam >= 1001 And wParam <= 2010 Then
             If wParam = 1002 Then
                 MsgBox "Sub submenu 1002 clicked"
                 Exit Function
             ElseIf wParam = 2001 Then
                 MsgBox "Sub submenu 2001 clicked"
                 Exit Function
             ElseIf wParam = 2002 Then
                 MsgBox "Sub submenu 2002 clicked"
                 Exit Function
             End If
             Exit Function
        End If
    ElseIf Msg = WM_SYSCOMMAND Then
        If wParam = 0 Then
             MsgBox "Inserted item clicked"
             Exit Function
        ElseIf wParam = 999 Then
             MsgBox "Appended item clicked"
             Exit Function
        End If
    End If
    NewWindowProc = CallWindowProc(OldWinProc, inHWND, Msg, wParam, lParam)
End Function



Public Sub RemoveOldProc(inHWND)
    Dim tmpProc As Long
    tmpProc = GetProp(inHWND, "OldWinProc")
    If tmpProc = 0 Then
        Exit Sub
    End If
    RemoveProp inHWND, "OldWinProc"
    SetWindowLong inHWND, GWL_WNDPROC, tmpProc
End Sub




